
import java.sql.*;
public class JDAB2 {
   static Connection conn = null;
   static Statement s = null;
   static ResultSet rs = null;
   static CallableStatement cs = null;
   static int mod []= new int[6];
   static String azon;
   static String rendszam;
   static String szin;
   static String tipus;
   static int kor;
   static int ar;
   static java.io.Console d = System.console();
   static String m[] = {"Azonost","Rendszm","Tipus","Szin","Kor","r"};
   static String mn[]= {"azon","rendszam","tipus","szin","kor","ar"};
   static String felt[] = new String[6];
   static int db=0;
   static int fdb=0;
   static String aktpar;
   static String user="";
   static String pswd="";

   public static void Kapcs(String user, String pswd){
     try {
        //String url = "jdbc:oracle:thin:@193.6.5.42:1521:info";
        String url = "jdbc:oracle:thin:@localhost:1521:XE";
        d.printf("\nKapcsolodas . . .");
        conn = DriverManager.getConnection(url, user, pswd);
        d.printf("\nKapcsolat: OK!");
     } catch(Exception e) {
        System.err.println(e.getMessage());
       }
   }

   public static void Lekapcs(){
     try {
       conn.close();
      d.printf("\nAdatbzis-kapcsolat lezrva.");
     } catch(Exception e) {
        d.printf("\n"+e.getMessage());
       }
   }

   public static void Kiir(String beazon){
      String sqlp = "select * from auto where auto.azon like'"+beazon+"'";
      System.out.println();
      d.printf("\nAz. Rendsz. Tpus                Szn           Kor r");
      d.printf("\n---------------------------------------------------------");
      System.out.println();
     try {
        s = conn.createStatement();
	s.executeQuery(sqlp);
	rs = s.getResultSet();
         while(rs.next()) {
	   azon = rs.getString("azon");
	   rendszam = rs.getString("rendszam");
	   tipus = rs.getString("tipus");
	   szin = rs.getString("szin");
	   kor = rs.getInt("kor");
	   ar = rs.getInt("ar");
	   d.printf(azon+" "+rendszam+" "+tipus+" "+szin+" "+kor+" "+ar+"\n");
	 }
           System.out.println();
           System.out.println();
	rs.close();
	} catch(Exception e) {
        d.printf("\n"+e.getMessage());
     }
   }

   public static void KiirNaplo(){
      String muv;String usrn;String esem;int stat;Date ip;
      String sqlp = "select * from naplo";
      System.out.println();
      d.printf("\nMvelet    Usernv    Idpont    Esemny                     Sttus");
      d.printf("\n-------------------------------------------------------------------");
      System.out.println();
     try {
        s = conn.createStatement();
	s.executeQuery(sqlp);
	rs = s.getResultSet();
        while(rs.next()) {
	   muv = rs.getString("muvelet");
	   usrn = rs.getString("usernev");
	   ip = rs.getDate("idopont");
	   esem = rs.getString("esemeny");
	   stat = rs.getInt("status");
	   d.printf(muv+" "+usrn+" "+ip+" "+esem+" "+stat+"\n");
	 }
        System.out.println();
        System.out.println();
	rs.close();
	} catch(Exception e) {
        d.printf("\n"+e.getMessage());
     }
   }

   public static void Tmaker(){
     String sqlp1 = "create table auto(azon char(4) NOT NULL,rendszam char(7),tipus char(20),szin char(14),kor number(2),ar number(8), CONSTRAINT auto_pk PRIMARY KEY (azon))";
     String sqlp2 = "create table naplo(muvelet char(10),usernev char(10),idopont date,esemeny varchar(35),status number(1))";
     try {
        s = conn.createStatement();
        s.executeQuery(sqlp1);
        d.printf("\nKsz az AUTO tbla");
        s.executeQuery(sqlp2);
        d.printf("\nKsz a NAPLO tbla");
     } catch(Exception e) {
        d.printf("\nGond van a tblk ltrehozsval:"+e.getMessage());
       }
   }

   public static void Alprog(int mod){
    String sqlp1 = "create or replace procedure auto_ins (az in auto.azon%type, rsz in auto.rendszam%type, tip in auto.tipus%type,"+
    " sz in auto.szin%type, ko in auto.kor%type, arr in auto.ar%type) is begin insert into auto values(az, rsz, tip, sz, ko, arr); end;";
    String sqlp2 = "create or replace procedure auto_mod (az in auto.azon%type, rsz in auto.rendszam%type, tip in auto.tipus%type,"+     "sz in auto.szin%type, ko in auto.kor%type, arr in auto.ar%type) is begin update auto set rendszam = rsz where azon like az;"+
    "update auto set tipus = tip where azon like az; update auto set szin = sz where azon like az;"+
    "update auto set kor = ko where azon like az; update auto set ar = arr where azon like az; end;";
    String sqlp3 = "create or replace procedure auto_del (az in auto.azon%type) is begin delete from auto where azon like az; end;";
    String sqlp4 = "create or replace function auto_ker (rsz in auto.rendszam%type) return auto.azon%type is az auto.azon%type:=''; begin select azon into az from auto where rendszam like rsz; return az; end;";
    String sqlp5 = "create or replace function auto_atlagar (az in auto.azon%type) return auto.ar%type is cursor c1 is select ar from auto where azon like az; darab number := 0; atlag auto.ar%type := 0; begin for cm in c1 loop atlag := atlag + cm.ar; darab := darab +1; end loop; return (atlag/darab); end;";
    String sqlp6 = "create or replace trigger auto_beszur after insert on auto for each row DECLARE begin INSERT INTO naplo values('insert',user,sysdate,'Beszrs az auto tblba',0); end;";
    String sqlp7 = "create or replace trigger auto_torol after delete on auto for each row DECLARE begin INSERT INTO naplo values('delete',user,sysdate,'Trls az auto tblbl',0); end;";
    String sqlp8 = "create or replace trigger auto_modosit after update on auto for each row DECLARE begin INSERT INTO naplo values('update',user,sysdate,'Mdosts az auto tblban',0); end;";
    String sqlp9 = "create or replace procedure naplo_mod is begin update naplo set status = 1 where status = 0; end;";
    String sqlp10 = "create or replace function tabla_szam (nev in char) return number is db number; begin select count(*) into db from user_tables where table_name like nev; return db; end;";
    String sqlp11 = "create or replace procedure naplo_mod2 is begin update naplo set status = 2 where status = 1; end;";
    String sqlp12 = "declare JobNo number; begin DBMS_JOB.SUBMIT(JobNo, 'naplo_mod2;', (SYSDATE+1/24), 'SYSDATE+1'); end;";

    String sqlp13 = "create or replace package auto_pack as procedure auto_ins (az in auto.azon%type, rsz in auto.rendszam%type, tip in auto.tipus%type, sz in auto.szin%type, ko in auto.kor%type, arr in auto.ar%type); procedure auto_del (az in auto.azon%type); procedure auto_udt (az in auto.azon%type, rsz in auto.rendszam%type, tip in auto.tipus%type, sz in auto.szin%type, ko in auto.kor%type, arr in auto.ar%type); function auto_ker (rsz in auto.rendszam%type) return auto.azon%type; function auto_atlagar (az in auto.azon%type) return auto.ar%type; end auto_pack;";

    String sqlp14 = "create or replace package body auto_pack as procedure auto_ins (az in auto.azon%type, rsz in auto.rendszam%type, tip in auto.tipus%type, sz in auto.szin%type, ko in auto.kor%type, arr in auto.ar%type) is begin insert into auto values(az, rsz, tip, sz, ko, arr); end; procedure auto_del (az in auto.azon%type) is begin delete from auto where azon like az; end; procedure auto_udt (az in auto.azon%type, rsz in auto.rendszam%type, tip in auto.tipus%type, sz in auto.szin%type, ko in auto.kor%type, arr in auto.ar%type) is begin update auto set rendszam = rsz where azon like az; update auto set tipus = tip where azon like az;     update auto set szin = sz where azon like az; update auto set kor = ko where azon like az; update auto set ar = arr where azon like az; end; function auto_ker (rsz in auto.rendszam%type) return auto.azon%type is az auto.azon%type:=''; begin select azon into az from auto where rendszam like rsz; return az; end; function auto_atlagar (az in auto.azon%type) return auto.ar%type is cursor c1 is select ar from auto where azon like az; darab number := 0; atlag auto.ar%type := 0; begin for cm in c1 loop atlag := atlag + cm.ar; darab := darab +1; end loop; return (atlag/darab); end; end auto_pack;";

     try {
        s = conn.createStatement();
        if (mod == 1) {s.executeQuery(sqlp1); d.printf("\nKsz az eljrs.");}
        if (mod == 2) {s.executeQuery(sqlp2); d.printf("\nKsz az eljrs.");}
        if (mod == 3) {s.executeQuery(sqlp3); d.printf("\nKsz az eljrs.");}
        if (mod == 4) {s.executeQuery(sqlp4); d.printf("\nKsz a fggvny.");}
        if (mod == 5) {s.executeQuery(sqlp5); d.printf("\nKsz a fggvny.");}
        if (mod == 6) {s.executeQuery(sqlp6); }
        if (mod == 7) {s.executeQuery(sqlp7); }
        if (mod == 8) {s.executeQuery(sqlp8); }
        if (mod == 9) {s.executeQuery(sqlp9); d.printf("\nKsz az eljrs.");}
        if (mod == 10) {s.executeQuery(sqlp10);}
        if (mod == 11) {s.executeQuery(sqlp11); d.printf("\nKsz az eljrs.");}
        if (mod == 12) {s.executeQuery(sqlp12); d.printf("\nKsz a JOB.");}
        if (mod == 13) {s.executeQuery(sqlp12); d.printf("\nKsz a csomag fejlce.");}
        if (mod == 14) {s.executeQuery(sqlp12); d.printf("\nKsz a csomag trzse.");}

     } catch(Exception e) {
        d.printf("\n"+e.getMessage());
       }
   }

   public static int Tablaszam(String nev){
    int db=0;
    String sqlp = "{? = call tabla_szam(?)}";
     try {
        cs = conn.prepareCall(sqlp);
        cs.registerOutParameter(1, java.sql.Types.INTEGER);
	cs.setString(2, nev);
	cs.executeQuery();
        db = cs.getInt(1);

     } catch(Exception e) {
        d.printf("\n"+e.getMessage());
       }
	return db;
   }

   public static void Tdel(){
     Alprog(10);
     String sqlp1 = "drop table auto";
     String sqlp2 = "drop table naplo";
     try {
        if (Tablaszam("AUTO")==1){
        Sor(5);
        d.printf("\nLtezik az AUTO tbla, megprblom letrlni.");
          s = conn.createStatement();
          s.executeQuery(sqlp1);
        System.out.println();
        d.printf("\nTrltem az AUTO tblt.");
        Stop();
        }
        if (Tablaszam("NAPLO")==1){
        Sor(5);
        d.printf("\nLtezik a NAPLO tbla, megprblom letrlni.");
          s = conn.createStatement();
          s.executeQuery(sqlp2);
        System.out.println();
        d.printf("\nTrltem a NAPLO tblt.");
        Stop();
        }
     } catch(Exception e) {
        d.printf("\n"+e.getMessage());
       }
   }


   public static void Beszur(){
    java.io.Console d = System.console();
       System.out.println();
       System.out.println();
    String azon = d.readLine("Krem az azonostt (max. 4 karakter): ");
    String rendszam = d.readLine("Krem a rendszmot (ABC-123 alakban): ");
    String tipus = d.readLine("Krem a tpust: ");
    String szin = d.readLine("Krem az aut sznt: ");
    int kor = Integer.parseInt(d.readLine("Krem az aut kort: "));
    int ar = Integer.parseInt(d.readLine("Krem az aut rt: "));
    String sqlp = "{call auto_ins(?, ?, ?, ?, ?, ?)}";
     try {
        cs = conn.prepareCall(sqlp);
	cs.setString(1, azon);
	cs.setString(2, rendszam);
	cs.setString(3, tipus);
	cs.setString(4, szin);
	cs.setInt(5, kor);
	cs.setInt(6, ar);
	cs.executeQuery();
	d.printf("\nRekord beszrva");
     } catch(Exception e) {
        d.printf("\n"+e.getMessage());
       }
   }

   public static void Modosit(){
       java.io.Console d = System.console();
       System.out.println();
       System.out.println();
       String beaz = d.readLine("Krem a mdostand rekord azonostjt: ");
       System.out.println();
       Kiir(beaz);
       System.out.println();
       System.out.println();
     for (int i=0; i<5 ;i++) mod[i]=0;
     String bersz = d.readLine("Rendszam: "+rendszam+" j rtk bersa vagy ENTER! : ");
     if (bersz.length()!=0) {mod[0]=1; rendszam=bersz;}
     String betipus = d.readLine("Tipus: "+tipus+" j rtk bersa vagy ENTER! : ");
     if (betipus.length()!=0) {mod[1]=1; tipus=betipus;}
     String beszin = d.readLine("Szin: "+szin+" j rtk bersa vagy ENTER! : ");
     if (beszin.length()!=0) {mod[2]=1; szin = beszin;}
     String bekor = d.readLine("Kor: "+kor+" j rtk bersa vagy ENTER! : ");
     if (bekor.length()!=0) {mod[3]=1; kor =(Integer.parseInt(bekor));}
     String bear = d.readLine("Ar: "+ar+" j rtk bersa vagy ENTER! : ");
     if (bear.length()!=0) {mod[4]=1; ar=(Integer.parseInt(bear));}

       String sqlp = "{call auto_mod(?, ?, ?, ?, ?, ?)}";
     try {
        cs = conn.prepareCall(sqlp);
	cs.setString(1, azon);
	cs.setString(2, rendszam);
	cs.setString(3, tipus);
	cs.setString(4, szin);
	cs.setInt(5, kor);
	cs.setInt(6, ar);
	cs.executeQuery();
	d.printf("\nRekord mdostva");
     } catch(Exception e) {
        d.printf("\n"+e.getMessage());
       }
   }

   public static void ModositNaplo(){
       String sqlp = "{call naplo_mod}";
     try {
        cs = conn.prepareCall(sqlp);
	cs.executeQuery();
	d.printf("\nRekord mdostva");
     } catch(Exception e) {
        d.printf("\n"+e.getMessage());
       }
   }

   public static void Feltolt(){
   String sqlp1 = "{call auto_ins('A001','WRF-834','Hyundai i30','fehr',1,2300000)}";
   String sqlp2 = "{call auto_ins('A002','KGB-007','Mercedes ML520','fekete',3,7500000)}";
   String sqlp3 = "{call auto_ins('A003','ART-985','Opel Astra','piros',8,900000)}";
   String sqlp4 = "{call auto_ins('A004','BZM-922','Lada Samara','szrke',18,150000)}";
   String sqlp5 = "{call auto_ins('A005','DER-300','Opel Corsa','piros',7,600000)}";
   String sqlp6 = "{call auto_ins('A006','HYB-111','Opel Corsa','piros',5,1200000)}";
   String sqlp7 = "{call auto_ins('A007','ZUG-666','Opel Manta','srga',31,800000)}";
   String sqlp8 = "{call auto_ins('A008','GUT-298','Mercedes C200','fehr',3,5600000)}";
   String sqlp9 = "{call auto_ins('A009','CHR-438','Lada Niva','szrke',27,600000)}";
   String sqlp10 = "{call auto_ins('A010','HWQ-071','Opel Vectra','fekete',3,4900000)}";
     try {
        cs = conn.prepareCall(sqlp1);cs.executeQuery();
        cs = conn.prepareCall(sqlp2);cs.executeQuery();
        cs = conn.prepareCall(sqlp3);cs.executeQuery();
        cs = conn.prepareCall(sqlp4);cs.executeQuery();
        cs = conn.prepareCall(sqlp5);cs.executeQuery();
        cs = conn.prepareCall(sqlp6);cs.executeQuery();
        cs = conn.prepareCall(sqlp7);cs.executeQuery();
        cs = conn.prepareCall(sqlp8);cs.executeQuery();
        cs = conn.prepareCall(sqlp9);cs.executeQuery();
        cs = conn.prepareCall(sqlp10);cs.executeQuery();
        d.printf("\n10 rekord beszrva!");
     } catch(Exception e) {
        d.printf("\n"+e.getMessage());
       }
   }

   public static void Torol(){
    java.io.Console d = System.console();
    String azon = d.readLine("Krem az azonostt: ");
    String sqlp = "{call auto_del(?)}";
     try {
        cs = conn.prepareCall(sqlp);
	cs.setString(1, azon);
	cs.executeQuery();
	d.printf("\nRekord trlve");
     } catch(Exception e) {
        d.printf("\n"+e.getMessage());
       }
   }

   public static void Keres(){
    java.io.Console d = System.console();
    String rsz = d.readLine("Krem a rendszmot: ");
    String sqlp = "{? = call auto_ker(?)}";
     try {
        cs = conn.prepareCall(sqlp);
        cs.registerOutParameter(1, java.sql.Types.CHAR);
	cs.setString(2, rsz);
	cs.executeQuery();
        String azon = cs.getString(1);
	d.printf("\nA "+rsz+" rendszm aut azonostja: "+azon);
     } catch(Exception e) {
        d.printf("\n"+e.getMessage());
       }
   }

   public static void Atlag(){
    java.io.Console d = System.console();
    String azonbe = d.readLine("Krem az azonostt: ");
    String sqlp = "{? = call auto_atlagar(?)}";
     try {
        cs = conn.prepareCall(sqlp);
        cs.registerOutParameter(1, java.sql.Types.INTEGER);
	cs.setString(2, azonbe);
	cs.executeQuery();
        int atlagar = cs.getInt(1);
     System.out.println();
        System.out.println("Az "+azonbe+" azonositoju autok atlagara: "+atlagar);
     System.out.println();
     } catch(Exception e) {
        d.printf("\n"+e.getMessage());
       }
   }
     public static void Stop() {
      System.out.println();
      System.out.println();
      String enter = d.readLine("OK! Mehetnk tovbb: nyomom az ENTER-t!");
     }
     public static void Sor(int n) {
      for (int i=1; i<=n; i++) System.out.println();
     }

public static void SpecKer() {
   java.io.Console c = System.console();
    db=0;
     for (int i=0; i<6 ;i++) felt[i]="";
     for (int i=0; i<6 ;i++) mod[i]=0;
    char valasz;
   if (fdb <3){
    Sor(10);
      d.printf("Specilis keresmodul\n");
      d.printf("---------------------\n");
      Sor(2);
      d.printf("A specilis keresmodul tetszleges felttelek esetn kilistzza\n");
      d.printf("az autk adatait.\n");
      System.out.println();
      d.printf("Tbb mezre is fogalmazhat felttel, ezek s (and) kapcsolattal\n");
      d.printf("kerlnek vgrehajtsra.\n");
      Sor(2);
      d.printf("A modul hasznlata:\n");
      d.printf("-------------------\n");
      System.out.println();
      d.printf("Fogalmazd meg valamelyik mezre a felttelt, s ha visszatrtl\n");
      d.printf("a menbe, adj meg jabb felttelt egy msik mezre.\n");
      System.out.println();
      d.printf("Akkor vlaszd a Vgrehajts opcit, ha ksz a teljes felttelsor!\n");
      System.out.println();
      d.printf("Ha a megjelen lista res, nincs eredmnye a keressnek!\n");
      d.printf("Ha rosszul fogalmazod meg a feltteleket, hibazenetet kapsz!\n");
      Sor(1);Stop();
      fdb++;
      }
    do{
      Sor(6);
      Beolv(" ",6);
      d.printf("       Az aktulis parancs: \n");
      System.out.println("       --------------------");
      System.out.println("       "+aktpar);
      Sor(1);
      d.printf("       Melyik mezre rjunk felttelt?\n");
      System.out.println("       -------------------------------");
      Sor(2);
      d.printf("       1: Azonost\n");
      System.out.println();
      d.printf("       2: Rendszm\n");
      System.out.println();
      d.printf("       3: Tpus\n");
      System.out.println();
      d.printf("       4: Szn\n");
      System.out.println();
      d.printf("       5: Kor\n");
      System.out.println();
      d.printf("       6: r\n");
      System.out.println();
      d.printf("       V: Vgrehajts \n");  
      System.out.println();
      d.printf("       <-: ");
      valasz = Character.toUpperCase(c.readLine().charAt(0));
      switch (valasz) {
        case '1': Beolv(m[0],0); Stop(); break;
        case '2': Beolv(m[1],1); Stop(); break;
        case '3': Beolv(m[2],2); Stop(); break;
        case '4': Beolv(m[3],3); Stop(); break;
        case '5': Beolv(m[4],4); Stop(); break;
        case '6': Beolv(m[5],5); Stop(); break;
      }
    }while (valasz!='V');
     Beolv(" ",7); Stop();
  }

     public static void Beolv(String mezonev, int k) {
     int i=0;
     Sor(20);
     if (k==0){
       d.printf("Brmilyen rtelmes felttel megadhat, pl.");
       System.out.println(" like 'A%' vagy = 'A006'");
       System.out.println();
       d.printf("A szvegkonstanst aposztrfok ");
       System.out.print("'... '");d.printf(" kz kell tenni!\n");
       Sor(2);
       d.printf("rd be a meznv mg a felttelt!\n");
       Sor(4);
       String fbe = d.readLine(mezonev+" ");
       if (fbe.length()!=0) {mod[0]=1; felt[0]=fbe;}
     }
     if (k==1){
       d.printf("Brmilyen rtelmes felttel megadhat, pl.");
       System.out.println(" like 'A%' vagy = 'ABC-567'");
       System.out.println();
       d.printf("A szvegkonstanst aposztrfok ");
       System.out.print("'... '");d.printf(" kz kell tenni!\n");
       Sor(2);
       d.printf("rd be a meznv mg a felttelt!\n");
       Sor(4);
       String fbe = d.readLine(mezonev+" ");
       if (fbe.length()!=0) {mod[1]=1; felt[1]=fbe;}
     }
     if (k==2){
       d.printf("Brmilyen rtelmes felttel megadhat, pl.");
       System.out.println(" like 'Opel%' vagy = 'm%'");
       System.out.println();
       d.printf("A szvegkonstanst aposztrfok ");
       System.out.print("'... '");d.printf(" kz kell tenni!\n");
       Sor(2);
       d.printf("rd be a meznv mg a felttelt!\n");
       Sor(4);
       String fbe = d.readLine(mezonev+" ");
       if (fbe.length()!=0) {mod[2]=1; felt[2]=fbe;}
     }
     if (k==3){
       d.printf("Brmilyen rtelmes felttel megadhat, pl.");
       System.out.println(" like 'piros%' vagy = '%kk'");
       System.out.println();
       d.printf("A szvegkonstanst aposztrfok ");
       System.out.print("'... '");d.printf(" kz kell tenni!\n");
       Sor(2);
       d.printf("rd be a meznv mg a felttelt!\n");
       Sor(4);
       String fbe = d.readLine(mezonev+" ");
       if (fbe.length()!=0) {mod[3]=1; felt[3]=fbe;}
     }
     if (k==4){
       d.printf("Brmilyen rtelmes felttel megadhat, elbb az opertort kell\n");
       d.printf("berni, azutn egy szkzt, vgl a szmkonstanst.\n");
       System.out.println();
       d.printf("Opertor lehet: =, <>, >, <, >=, <=\n");
       Sor(2);
       d.printf("rd be a felttelt, aztn ENTER!\n");
       Sor(4);
       String fbe = d.readLine(mezonev+" ");
       if (fbe.length()!=0) {mod[4]=1; felt[4]=fbe;}
      }

     if (k==5){
       d.printf("Brmilyen rtelmes felttel megadhat, elbb az opertort kell\n");
       d.printf("berni, aztn ENTER, ezutn a szmkonstanst.\n");
       System.out.println();
       d.printf("Opertor lehet: =, <>, >, <, >=, <=\n");
       Sor(2);
       d.printf("rd be a felttelt, aztn ENTER!\n");
       Sor(4);
       String fbe = d.readLine(mezonev+" ");
       if (fbe.length()!=0) {mod[5]=1; felt[5]=fbe;}     
      }

     if (k==6){
       String sqlp = "select * from auto where ";
       for (i=0; i<6 ;i++) if (mod[i]== 1) db+=1;
       int dk=0;
	   if (mod[0]== 1){sqlp = sqlp+mn[0]+" "+felt[0];dk+=1;}
           if (dk > 0 && mod[1]== 1) {sqlp = sqlp +" and ";}
           if (mod[1]== 1){sqlp = sqlp +mn[1]+" "+felt[1];dk+=1;}
           if (dk > 0 && mod[2]== 1) {sqlp = sqlp +" and ";}
           if (mod[2]== 1){sqlp = sqlp +mn[2]+" "+felt[2];dk+=1;}
           if (dk > 0 && mod[3]== 1) {sqlp = sqlp +" and ";}
           if (mod[3]== 1){sqlp = sqlp +mn[3]+" "+felt[3];dk+=1;}
           if (dk > 0 && mod[4]== 1) {sqlp = sqlp +" and ";}
           if (mod[4]== 1){sqlp = sqlp +mn[4]+" "+felt[4];dk+=1;}
           if (dk > 0 && mod[5]== 1) {sqlp = sqlp +" and ";}
           if (mod[5]== 1){sqlp = sqlp +mn[5]+" "+felt[5];}
       aktpar=sqlp;
     }

     if (k==7){
      System.out.println("  "+aktpar);
      System.out.println();
      d.printf("\nAz. Rendsz. Tpus                Szn           Kor r");
      d.printf("\n---------------------------------------------------------");
      System.out.println();
     try {
        s = conn.createStatement();
	s.executeQuery(aktpar);
	rs = s.getResultSet();
         while(rs.next()) {
	   azon = rs.getString("azon");
	   rendszam = rs.getString("rendszam");
	   tipus = rs.getString("tipus");
	   szin = rs.getString("szin");
	   kor = rs.getInt("kor");
	   ar = rs.getInt("ar");
	   d.printf(azon+" "+rendszam+" "+tipus+" "+szin+" "+kor+" "+ar+"\n");
	 }
           System.out.println();
           System.out.println();
	rs.close();
	} catch(Exception e) {
        d.printf("\n"+e.getMessage());
        }
    }
}

     public static void menu1() {
   java.io.Console c = System.console();
    char valasz;
    do{
    Sor(13);
      d.printf("       Tbla: AUTO\n");
      System.out.println("       -----------");
      Sor(3);
      d.printf("       1: Lista\n");
      System.out.println();
      d.printf("       2: Beszrs\n");
      System.out.println();
      d.printf("       3: Mdosts\n");
      System.out.println();
      d.printf("       4: Trls\n");
      System.out.println();
      d.printf("       5: Keress rendszmra\n");
      System.out.println();
      d.printf("       6: tlagr\n");
      System.out.println();
      d.printf("       7: Spci keress\n");
      System.out.println();
      d.printf("       V: Vissza a fmenbe \n");
      System.out.println();
      d.printf("       <-: ");
      valasz = Character.toUpperCase(c.readLine().charAt(0));
      switch (valasz) {
        case '1': Kiir("%");Stop(); break;
        case '2': Beszur(); Stop(); break;
        case '3': Modosit(); Stop(); break;
        case '4': Torol(); Stop(); break;
        case '5': Kiir("%");Keres(); Stop(); break;
        case '6': Atlag(); Stop(); break;
        case '7': SpecKer(); break;
      }
    }while (valasz!='V');
  }

   public static void menu2() {
   java.io.Console c = System.console();
    char valasz;
    do{
    Sor(16);
      d.printf("       Tbla: NAPLO\n");
      System.out.println("       -----------");
      Sor(3);
      d.printf("       1: Lista\n");
      System.out.println();
      d.printf("       V: Vissza a fmenbe \n");
      System.out.println();
      d.printf("       <-: ");
      valasz = Character.toUpperCase(c.readLine().charAt(0));
      switch (valasz) {
        case '1': KiirNaplo(); Stop(); ModositNaplo(); break;
       }
    }while (valasz!='V');
  }


 public static void menu() {
   java.io.Console c = System.console();
    char valasz;
    do{
    Sor(13);
      d.printf("   Java Demo AdatBzis 2 (v01.43) - by BitMan\n");
      System.out.print("   ------------------------------------------");
      Sor(5);
      d.printf("       1: AUTO tbla kezelse\n");
      System.out.println();
      d.printf("       2: NAPLO tbla kezelse\n");
      System.out.println();
      d.printf("       V: Vge \n");
      System.out.println();
      d.printf("       <-: ");
      valasz = Character.toUpperCase(c.readLine().charAt(0));
      switch (valasz) {
        case '1': menu1(); break;
        case '2': menu2(); break;
      }
    }while (valasz!='V');
  }

 public static void menu0() {
   java.io.Console c = System.console();
    char valasz;
    do{
    Sor(13);
      System.out.print("   ");
                 d.printf("Java Demo AdatBzis 2 (v01.43) - by BitMan\n");
      System.out.print("   ------------------------------------------");
      Sor(5);
      d.printf("       1: Oktat\n");
      System.out.println();
      d.printf("       2: kezel\n");
      System.out.println();
      d.printf("       V: Vge \n");
      System.out.println();
      d.printf("       <-: ");
      valasz = Character.toUpperCase(c.readLine().charAt(0));
      switch (valasz) {
        case '1': oktat(); break;
        case '2': kezel(); break;
      }
    }while (valasz!='V');
  }

public static void oktat(){

     d.printf("\nA program megfelel mkdshez szksges, hogy a VirtualOracleXE szerverre");
     d.printf("\nlegyen belpsi jogosultsgod. E nlkl a program men hasznlhat!");
     System.out.println();
     d.printf("\nA program ltrehoz egy AUTO nev tblt. Ha ltezne ilyen nev tbla,");
     d.printf("\nakkor elbb (ha tudja) letrli a meglvt.");
     System.out.println();
     System.out.println();
     d.printf("\nA program elmagyarzza a JDBC-vel trtn adatbzis-kezels alapjait,");
     d.printf("\nltrehozza az objektumokat, s bemutatja azok hasznlatt.");
     System.out.println();
     System.out.println();
     d.printf("\nTedd a kezed az ENTER-re, s ha a program kri, nyomd meg.");
     System.out.println();
     String enter = d.readLine("                                                 Most: ENTER!");
      Sor(24);
     if (user.length()==0){
        user = d.readLine("Krem a VirtualOracleXE azonositt: (system)");
        char[] pswdc = d.readPassword("Krem a jelszt [Nem rdik ki!!!] (jelszo): ");
        pswd = new String(pswdc);
     }
      Sor(12);
     d.printf("\nKiptem az adatbzis kapcsolatot.");
     System.out.println();
     System.out.println();
     d.printf("\nA kvetkez java parancsok kerlnek kiadsra:");
     System.out.println();
     d.printf("\nurl = jdbc:oracle:thin:@localhost:1521:XE");
     d.printf("\nConnection conn = DriverManager.getConnection(url, neved, jelszavad);");
     System.out.println();
     System.out.println();
             d.printf("\nMagyarzatok:\n");
     System.out.println("-------------");
     d.printf("\nConnection conn : Kapcsolat vltoz ltrehozsa");
     d.printf("\nDriverManager.getConnection(url,user,pswd) : Kapcsolat megteremtse");
     System.out.println();
     System.out.println();
     System.out.println();
     enter = d.readLine("Ha indulhat a mvelet, nyomj ENTER-t!");
      Sor(12);
  Kapcs(user, pswd);
      Sor(12);

  Tdel();
      Sor(12);
     d.printf("\nMost nzzk, hogyan kell ltrehozni a szksges tblkat!");
     System.out.println();
     d.printf("\nA kvetkez tblkat fogjuk hasznlni:");
     System.out.println();
     System.out.println();
     d.printf("\nAUTO [azonosito, rendszam, tipus, szin, kor, ar]");
     System.out.println();
     d.printf("\nNAPLO [muvelet, usernev, idopont, esemeny, status]");
     System.out.println();
     System.out.println();
             d.printf("\nMagyarzatok:\n");
     System.out.println("-------------");
     d.printf("\nAUTO: Hasznlt autk adatai.");
     System.out.println();
     d.printf("\nNAPLO: A vgrehajtott DML mveletek naplzsa.");
     System.out.println();
     System.out.println();
     enter = d.readLine("Ha mehetnk tovbb, nyomj ENTER-t!");
      Sor(12);
     d.printf("\nA tblk elksztshez jvbl a kvetkez parancsok segtsgvel trtnik:");
     System.out.println();
     d.printf("\nStatement s = conn.createStatement();");
     d.printf("\ns.executeQuery(create table auto(azon char(4) NOT NULL,rendszam char(7),tipus char(20),szin char(14),kor number(2),ar number(8), CONSTRAINT auto_pk PRIMARY KEY (azon))");
     System.out.println();
     System.out.println();
             d.printf("\nMagyarzatok:\n");
     System.out.println("-------------");
     d.printf("\nStatement s : Sql kifejezst kezel vltoz ltrehozsa");
     d.printf("\nconn.createStatement() : A kapcsolathoz rendeljk az sql vltozt");
     d.printf("\ns.executeQuery(...) : Vgrehajtjuk az sql vltozban lv parancsot");
     System.out.println();
     System.out.println();
     d.printf("\nUgyangy jn ltre a NAPLO tbla is:");
     System.out.println();
     d.printf("\nStatement s = conn.createStatement();");
     d.printf("\ns.executeQuery(create table naplo(muvelet char(10),usernev char(10),idopont date,esemeny varchar(35),status number(1))");
      Sor(3);
     enter = d.readLine("A tblk ltrehozshoz nyomj ENTER-t!");
      Sor(20);
     Tmaker();
     Alprog(6);Alprog(7);Alprog(8);
      Stop();
      Sor(12);
     d.printf("\nKsztsnk egy trolt eljrst adatfelvitelre az AUTO tblhoz:\n");
     System.out.println();
     System.out.println();
     System.out.println("create or replace procedure auto_ins (az in auto.azon%type,");
     System.out.println("rsz in auto.rendszam%type, tip in auto.tipus%type,");
     System.out.println("sz in auto.szin%type, ko in auto.kor%type, arr in auto.ar%type) is");
     System.out.println("    begin");
     System.out.println("      insert into auto values(az, rsz, tip, sz, ko, arr);");
     System.out.println("    end;");
     System.out.println();
             d.printf("\nMagyarzatok:\n");
     System.out.println("-------------");
     d.printf("\nMost lelhetnl egy tvoli Oracle szerver webes fellete, az ISQL+ ablak el,");
     d.printf("\nbejelentkezhetnl, s begpelhetnd az utastsokat. gy ltrejnne");
     d.printf("\naz auto_ins nev trolt eljrs.");
     System.out.println();
     d.printf("\nHa ezt teszed, s hibazenetet kapsz, add ki a SHOW ERRORS parancsot,");
     d.printf("\ngy rszletes kimutatst kapsz a hibkrl.\n");
     System.out.println();
     System.out.println();
     enter = d.readLine("OK. Ezt rtem, mehetnk tovbb: nyomom az ENTER-t!");
      Sor(12);

     d.printf("\nHa viszont jvbl szeretnd elkszteni az eljrst, a kvetkez");
     d.printf("\nparancsokat kell kiadnod:\n");
     System.out.println();
     System.out.println();
     System.out.println("Statement s = conn.createStatement();");
     System.out.println("s.executeQuery(create or replace procedure auto_ins (az in auto.azon%type, rsz in auto.rendszam%type, tip in auto.tipus%type, sz in auto.szin%type, ko in auto.kor%type, arr in auto.ar%type) is begin insert into auto values(az, rsz, tip, sz, ko, arr); end;)");
     System.out.println();
             d.printf("\nTeht:\n");
     System.out.println("------");
     System.out.println("Statement s = conn.createStatement();");
     d.printf("s.executeQuery(... egyetlen stringbe berjuk a parancsokat, s vgrehajtjuk...);");
      Sor(3);
     enter = d.readLine("Ha kezddhet az eljrs ltrehozsa, nyomj ENTER-t!");
     Sor(20);
     Alprog(1);
     Sor(2);
     d.printf("\nHa az ISQL+ ablakban begpelnd a kvetkez utastst:");
     System.out.println();
     System.out.println("select object_type, object_name from user_objects");
     System.out.println("where object_type = 'PROCEDURE' or object_type = 'FUNCTION';");
     System.out.println();
     d.printf("\nkirdna a trolt eljrsok tpusa, neve.");
     Sor(2);
     enter = d.readLine("Tovbb: ENTER!");
      Sor(20);
     System.out.println();
     d.printf("\nNzzk, hogyan kell meghvni az eljrst:");
     System.out.println();
             d.printf("\nAz ISQL+ ablakban: \n");
     System.out.println("------------------");
     System.out.println("execute auto_ins('A013','ABC-987','Opel Manta','piros',32,450000)");
      Sor(10);
     enter = d.readLine("OK. Ezt rtem, mehetnk tovbb: nyomom az ENTER-t!");
      Sor(10);
             d.printf("\nAz eljrs meghvsa jvbl: \n");
     System.out.println("-----------------------------");
     d.printf("\nBillentyzetrl beolvassuk az azonost, rendszm... adatokat, ezutn:\n");
     System.out.println();
     System.out.println("CallableStatement cs = conn.prepareCall({call auto_ins(?, ?, ?, ?, ?, ?)}");
     System.out.println("cs.setString(1, azon);");
     System.out.println("cs.setString(2, rendszam);");
     System.out.println("cs.setString(3, tipus);");
     System.out.println("cs.setString(4, szin);");
     System.out.println("cs.setInt(5, kor);");
     System.out.println("cs.setInt(6, ar);");
     System.out.println("cs.executeQuery();");
     System.out.println();
     d.printf("\nA krdjelek sorrendjben megadjuk a szksges paramtereket,");
     d.printf("\nvgl vgrehajtjuk az sszelltott, paramterekkel konkretizlt parancsot.\n");
             d.printf("Teht:\n");
     System.out.println("------");
     d.printf("CallableStatement cs : vltoz az adatbzisban trolt eljrsok futtatsra\n");
     d.printf("prepareCall() : a hv sql parancs sszelltsa paramterek segtsgvel\n");
     d.printf("conn.prepareCall(...) : a hv sql parancs hozzrendelse a kapcsolathoz\n");
     d.printf("cs.executeQuery(); - A parancs vgrehajtsa\n");
     System.out.println();
     enter = d.readLine("Az adatfelvitel kiprblshoz nyomj ENTER-t!");
      Sor(20);
     Beszur();
      Sor(2);
     enter = d.readLine("Tovbb: ENTER!");
      Sor(20);
     enter = d.readLine("Most feltltm nhny rekorddal a tblt, a kezdshez nyomj ENTER-t!");
      Sor(2);
     Feltolt();
      Sor(2);
     enter = d.readLine("Tovbb: ENTER!");
      Sor(20);
     d.printf("\nKsztsnk egy trolt eljrst adatmdostsra az AUTO tblhoz:");
      Sor(2);
     System.out.println("create or replace procedure auto_mod (az in auto.azon%type,");
     System.out.println("rsz in auto.rendszam%type, tip in auto.tipus%type, sz in auto.szin%type,");
     System.out.println("ko in auto.kor%type, arr in auto.ar%type) is");
     System.out.println("  begin");
     System.out.println("    update auto set rendszam = rsz where azon like az;");
     System.out.println("    update auto set tipus = tip where azon like az;");
     System.out.println("    update auto set szin = sz where azon like az;");
     System.out.println("    update auto set kor = ko where azon like az;");
     System.out.println("    update auto set ar = arr where azon like az;");
     System.out.println("  end;");
     System.out.println();
     d.printf("\nEgyszerre csak egy mez mdosthat, ezrt minden mezre runk egy update-et.");
     d.printf("\nUgyangy jrunk el, mint az elbb:");
      Sor(2);
     System.out.println("Statement s = conn.createStatement();");
     d.printf("s.executeQuery(...stringknt berjuk a parancsokat... s vgrehajtjuk!)");
      Sor(2);
     enter = d.readLine("Ha kezddhet az eljrs ltrehozsa, nyomj ENTER-t!");
      Sor(13);
     Alprog(2);
      Sor(2);
     enter = d.readLine("Tovbb: ENTER!");
      Sor(20);
     d.printf("\nNzzk, hogyan kell meghvni az eljrst:");
     System.out.println();
     d.printf("\nBillentyzetrl beolvassuk az azonost, rendszm... adatokat, ezutn:");
     System.out.println();
     System.out.println("CallableStatement cs = conn.prepareCall({call auto_mod(?, ?, ?, ?, ?, ?)}");
     System.out.println();
     d.printf("\nA krdjelek sorrendjben megadjuk a paramtereket:");
     System.out.println();
     System.out.println("cs.setString(1, azon);");
     System.out.println("cs.setString(2, rendszam);");
     System.out.println("cs.setString(3, tipus);");
     System.out.println("cs.setString(4, szin);");
     System.out.println("cs.setInt(5, kor);");
     System.out.println("cs.setInt(6, ar);");
     System.out.println();
     d.printf("\ncs.executeQuery();");
     System.out.println();
     d.printf("\nVgl vgrehajtjuk az sszelltott parancsot:");
      Sor(2);
     enter = d.readLine("A mdostshoz kiprblshoz nyomj ENTER-t!");
      Sor(20);
     d.printf("\nSegtsgl kirom a ltez rekordokat:");
     Kiir("%");
     Modosit();
      Sor(2);
     enter = d.readLine("Tovbb: ENTER!");
      Sor(20);
     d.printf("\nKsztsnk egy trolt eljrst, amely kitrl egy rekordot az AUTO tblbl:");
      Sor(2);
     System.out.println("create or replace procedure auto_del (az in auto.azon%type) is");
     System.out.println("  begin");
     System.out.println("     delete from auto where azon like az;");
     System.out.println("  end;");
     System.out.println();
     d.printf("\nJvbl a kvetkez parancsokat kell kiadnunk az eljrs elksztshez:");
     System.out.println();
     System.out.println("Statement s = conn.createStatement();");
     System.out.println("s.executeQuery(create or replace procedure auto_del (az in auto.azon%type) is begin delete from auto where azon like az; end;)");
      Sor(2);
     enter = d.readLine("Ha kezddhet az eljrs ltrehozsa, nyomj ENTER-t!");
     Alprog(3);
      Sor(3);
     enter = d.readLine("Tovbb: ENTER!");
      Sor(20);
     d.printf("\nNzzk, hogyan kell meghvni az eljrst:");
     System.out.println();
     d.printf("\nBillentyzetrl beolvassuk az azonostt, ezutn:");
      Sor(2);
     System.out.println("CallableStatement cs = conn.prepareCall({call auto_del(?)}");
     System.out.println("cs.setString(1, azon);");
     System.out.println("cs.executeQuery();");
      Sor(2);
     enter = d.readLine("A trls kiprblshoz nyomj ENTER-t!");
     System.out.println();
     d.printf("\nSegtsgl kirom a ltez rekordokat:");
     Kiir("%");
      Sor(2);
     Torol();

      Sor(5);
     enter = d.readLine("Tovbb: ENTER!");
      Sor(20);
     d.printf("\nKsztsnk egy trolt fggvnyt, amely egy rendszm esetn visszaadja");
     d.printf("\naz aut azonostjt:");
      Sor(2);
     System.out.println("create or replace function auto_ker (rsz in auto.rendszam%type)");
     System.out.println("return auto.azon%type is");
     System.out.println("  az auto.azon%type:='';");
     System.out.println("  begin");
     System.out.println("     select azon into az from auto where rendszam like rsz;");
     System.out.println("     return az;");
     System.out.println("  end;");
     System.out.println();
     d.printf("\nJvbl a kvetkez parancsokat kell kiadnunk a fggvny elksztshez:");
      Sor(2);
     System.out.println("Statement s = conn.createStatement();");
     System.out.println("s.executeQuery(create or replace function auto_ker (rsz in auto.rendszam%type) return auto.azon%type is az auto.azon%type:=''; begin select azon into az from auto where rendszam like rsz; return az; end;)");
     System.out.println();
     enter = d.readLine("Ha kezddhet a fggvny ltrehozsa, nyomj ENTER-t!");
     Alprog(4);
      Sor(4);
     enter = d.readLine("Tovbb: ENTER!");
      Sor(20);
     d.printf("\nNzzk, hogyan kell meghvni a fggvnyt:");
     System.out.println();
     d.printf("\nBillentyzetrl beolvassuk a rendszmot, ezutn:");
      Sor(2);
     System.out.println("CallableStatement cs = conn.prepareCall({? = call auto_ker(?)}");
     System.out.println("cs.registerOutParameter(1, java.sql.Types.CHAR);");
     System.out.println("cs.setString(2, rsz);");
     System.out.println("cs.executeQuery();");
     System.out.println("String azon = cs.getString(1);");
     System.out.println();
     d.printf("\nEzutn jvbl kirjuk az azonostt.");
     System.out.println();
     enter = d.readLine("A keress kiprblshoz nyomj ENTER-t!");
     System.out.println();
     d.printf("\nSegtsgl kirom a ltez rekordokat:");
     Kiir("%");
     System.out.println();
     Keres();
      Sor(4);
     enter = d.readLine("Tovbb: ENTER!");
      Sor(20);
     d.printf("\nKsztsnk egy trolt fggvnyt, amely kiszmtja megadott azonostj autk tlagrt:");
     System.out.println();
     System.out.println("create or replace function auto_atlagar (az in auto.azon%type) return auto.ar%type is");
     System.out.println("  cursor c1 is select ar from auto where azon like az;");
     System.out.println("  darab number := 0;");
     System.out.println("  ossz auto.ar%type := 0;");
     System.out.println("  begin");
     System.out.println("     for cm in c1 loop");
     System.out.println("        ossz := ossz + cm.ar;");
     System.out.println("        darab := darab +1;");
     System.out.println("     end loop;");
     System.out.println("     return (ossz/darab);");
     System.out.println("  end;");
     System.out.println();
     d.printf("\nJvbl a kvetkez parancsokat kell kiadnunk a fggvny elksztshez:");
      Sor(2);
     System.out.println("Statement s = conn.createStatement();");
     d.printf("s.executeQuery(...stringknt berjuk a parancsokat... s vgrehajtjuk!)");
      Sor(2);
     enter = d.readLine("Ha kezddhet a fggvny ltrehozsa, nyomj ENTER-t!");
     Alprog(5);
      Sor(4);
     enter = d.readLine("Tovbb: ENTER!");
      Sor(20);
     d.printf("\nNzzk, hogyan kell meghvni a fggvnyt:");
     System.out.println();
     d.printf("\nBillentyzetrl beolvassuk az azonostt, ezutn:");
      Sor(2);
     System.out.println("CallableStatement cs = conn.prepareCall({? = call auto_atlagar(?)}");
     System.out.println("cs.registerOutParameter(1, java.sql.Types.INTEGER);");
     System.out.println("cs.setString(2, azon);");
     System.out.println("cs.executeQuery();");
     System.out.println("int atlagar = cs.getInt(1);");
      Sor(2);
     d.printf("\nEzutn jvbl kirjuk az tlagrat.");
      Sor(2);
     enter = d.readLine("A fggvny kiprblshoz nyomj ENTER-t!");
     System.out.println();
     d.printf("\nEllenrzsknt kirom a ltez rekordokat:");
     Kiir("%");
     System.out.println();
     Atlag();
      Sor(2);
     enter = d.readLine("Tovbb: ENTER!");
      Sor(20);

     d.printf("Csomagoljunk.\n");
     d.printf("Az eddig elksztett trolt eljrsokat helyezzk el egy csomagban:\n");
     d.printf("A csomagot kt kln utastssal hozzuk ltre. Elszr a csomag fejrszt:\n");
      Sor(2);
     System.out.println("create or replace package auto_pack as");
     System.out.println("procedure auto_ins (az in auto.azon%type, rsz in auto.rendszam%type, tip in auto.tipus%type, sz in auto.szin%type, ko in auto.kor%type, arr in auto.ar%type);");
     System.out.println("procedure auto_del (az in auto.azon%type);");
     System.out.println("procedure auto_udt (az in auto.azon%type, rsz in auto.rendszam%type, tip in auto.tipus%type, sz in auto.szin%type, ko in auto.kor%type, arr in auto.ar%type);");
     System.out.println("function auto_ker (rsz in auto.rendszam%type) return auto.azon%type;");
     System.out.println("function auto_atlagar (az in auto.azon%type) return auto.ar%type;");
     System.out.println("end auto_pack;");
     System.out.println();
     d.printf("\nTeht: Az sszes eljrs s fggvny fejrszt berjuk a csomag fejrszbe.");
     System.out.println();
     enter = d.readLine("Ha kezddhet a csomag fejrsznek ltrehozsa, nyomj ENTER-t!");
     Alprog(13);
      Sor(4);
     enter = d.readLine("Tovbb: ENTER!");
      Sor(20);



     d.printf("A msodik utastssal ltre hozzuk a csomag trzst:\n");
     System.out.println();
     System.out.println("create or replace package body auto_pack as");
     System.out.println("procedure auto_ins (az in auto.azon%type, rsz in auto.rendszam%type, tip in auto.tipus%type, sz in auto.szin%type, ko in auto.kor%type, arr in auto.ar%type) is");
     System.out.println("   begin");
     System.out.println("    insert into auto values(az, rsz, tip, sz, ko, arr);");
     System.out.println("   end;");
     System.out.println("procedure auto_del (az in auto.azon%type) is");
     System.out.println("  begin");
     System.out.println(" . . .");
     System.out.println(" . . .");
     System.out.println("	    end loop;");
     System.out.println("	   return (atlag/darab);");
     System.out.println("          end;");
     System.out.println("end auto_pack;");
     System.out.println();
     d.printf("Teht: Az sszes eljrst s fggvnyt teljes egszben berjuk a\n");
     d.printf("csomag trzsbe.\n");
     System.out.println();
     enter = d.readLine("Ha kezddhet a csomag trzsnek ltrehozsa, nyomj ENTER-t!");
     Alprog(14);
      Sor(4);
     enter = d.readLine("Tovbb: ENTER!");
      Sor(20);

     d.printf("A csomag ltrehozsa utn a benne lv trolt eljrsokra\n");
     d.printf("minstett hivatkozssal kell utalnunk:\n");
     System.out.println();
     d.printf("Indtsuk el az auto_del eljrst:\n");
     System.out.println();
     System.out.println("CallableStatement cs = conn.prepareCall({call auto_pack.auto_del(?)}");
     System.out.println("cs.setString(1, azon);");
     System.out.println("cs.executeQuery();");
     System.out.println();
     d.printf("Teht: Az eljrs neve el ki kell rni a csomag nevt!\n");
      Sor(2);
     enter = d.readLine("Tovbb: ENTER!");

      Sor(20);
     d.printf("\nKsztsnk egy triggert, amely minden egyes beszrsi mveletnl beszr");
     d.printf("\negy rekordot a NAPLO [muvelet, usernev, idopont, esemeny, status] tblba:");
      Sor(2);
     System.out.println("create or replace trigger auto_beszur after insert on auto for each row");
     System.out.println(" begin");
     System.out.println("  INSERT INTO naplo values('insert',user,sysdate,'Beszuras az auto tablaba',0);");
     System.out.println(" end;");
     System.out.println();
     d.printf("\nJvbl a kvetkez parancsokat kell kiadnunk a fggvny elksztshez:");
      Sor(2);
     System.out.println("Statement s = conn.createStatement();");
     d.printf("s.executeQuery(...stringknt berjuk a trigger parancsait... s vgrehajtjuk!)");
      Sor(4);
     enter = d.readLine("Tovbb: ENTER!");
       Sor(20);
     d.printf("\nMost egy olyan triggert ksztnk, amely minden egyes trlsi mveletnl beszr");
     d.printf("\negy rekordot a NAPLO tblba:");
      Sor(2);
     System.out.println("create or replace trigger auto_torol after delete on auto for each row");
     System.out.println(" begin");
     System.out.println("  INSERT INTO naplo values('delete',user,sysdate,'Torles az auto tablabol',0);");
     System.out.println(" end;");
     System.out.println();
     d.printf("\nJvbl a kvetkez parancsokat kell kiadnunk a fggvny elksztshez:");
      Sor(2);
     System.out.println("Statement s = conn.createStatement();");
     d.printf("s.executeQuery(...stringknt berjuk a trigger parancsait... s vgrehajtjuk!)");
      Sor(4);
     enter = d.readLine("Tovbb: ENTER!");
      Sor(20);
     d.printf("\nMost egy olyan triggert ksztnk, amely minden egyes mdostsnl beszr");
     d.printf("\negy rekordot a NAPLO tblba:");
      Sor(2);
     System.out.println("create or replace trigger auto_modosit after update on auto for each row");
     System.out.println(" begin");
     System.out.println(" INSERT INTO naplo values('update',user,sysdate,'Mdosts az auto tblban',0);");
     System.out.println(" end;");
     System.out.println();
     d.printf("\nJvbl a kvetkez parancsokat kell kiadnunk a fggvny elksztshez:");
      Sor(2);
     System.out.println("Statement s = conn.createStatement();");
     d.printf("s.executeQuery(...stringknt berjuk a trigger parancsait... s vgrehajtjuk!)");
      Sor(4);
     enter = d.readLine("Tovbb: ENTER!");
      Sor(20);
     d.printf("\nA triggereket kzvetlenl a tblk ltrehozsa utn ltrehozta a program,");
     d.printf("\ngy azok azta mkdtek.");
      Sor(2);
     d.printf("\nNzzk a NAPLO tblt, milyen bejegyzsek kerltek bele:");
     System.out.println();
     KiirNaplo();
     enter = d.readLine("Tovbb: ENTER!");

       Sor(20);
     d.printf("\nrjunk egy olyan trolt eljrst, amely mdostja a NAPLO tblban");
     d.printf("\na status rtkt 0-rl 1-re.");
      Sor(2);
     System.out.println("create or replace procedure naplo_mod is");
     System.out.println(" begin");
     System.out.println(" update naplo set status = 1 where status = 0;");
     System.out.println(" end;");
     System.out.println();
     d.printf("\nJvbl a kvetkez parancsokat kell kiadnunk az eljrs elksztshez:");
      Sor(2);
     System.out.println("Statement s = conn.createStatement();");
     d.printf("s.executeQuery(...stringknt berjuk az eljrs parancsait... s vgrehajtjuk!)");
      Sor(4);
     enter = d.readLine("Hozzuk ltre az eljrst. Tovbb: ENTER!");
      Sor(2);
     Alprog(9);
      Sor(4);
     enter = d.readLine("Tovbb: ENTER!");
      Sor(20);
     d.printf("\nA status mdostshoz indtsuk el a naplo_mod eljrst:");
      Sor(2);
     System.out.println("CallableStatement cs = conn.prepareCall({call naplo_mod}");
     System.out.println("cs.executeQuery();");
      Sor(3);
      ModositNaplo();
      Sor(2);
     enter = d.readLine("Vgl: Nzzk meg a NAPLO tblt. Tovbb: ENTER!");
      Sor(13);
     KiirNaplo();
      Sor(2);
     enter = d.readLine("Tovbb: ENTER!");
      Sor(20);



     d.printf("\nrjunk egy olyan trolt eljrst, amely mdostja a NAPLO tblban");
     d.printf("\na status rtkt 1-rl 2-re.\n");
     d.printf("\nEzt a trolt eljrst fogjuk felhasznlni egy JOB elksztshez.");
      Sor(2);
     System.out.println("create or replace procedure naplo_mod2 is");
     System.out.println(" begin");
     System.out.println(" update naplo set status = 1 where status = 0;");
     System.out.println(" end;");
     System.out.println();
     d.printf("\nJvbl a kvetkez parancsokat kell kiadnunk az eljrs elksztshez:");
      Sor(2);
     System.out.println("Statement s = conn.createStatement();");
     d.printf("s.executeQuery(...stringknt berjuk az eljrs parancsait... s vgrehajtjuk!)");
      Sor(4);
     enter = d.readLine("Hozzuk ltre az eljrst. Tovbb: ENTER!");
      Sor(2);
     Alprog(11);
      Sor(4);
     enter = d.readLine("Tovbb: ENTER!");
      Sor(20);
     d.printf("Ksztsk egy JOB-ot, mely automatikusan trlend sttuszra lltja az\n");
     d.printf("olvasott bejegyzseket minden nap egy bizonyos idpontban:\n");
      Sor(2);
     System.out.println(" declare");
     System.out.println(" JobNo number;");
     System.out.println(" begin");
     System.out.println(" DBMS_JOB.SUBMIT(JobNo, 'naplo_mod2;', (SYSDATE+1/24), 'SYSDATE+1');");
     System.out.println(" end;");
     System.out.println();
     d.printf("Egy blokkba kerl a JOB, a JobNo vltozt deklarlni kell.\n");
     d.printf("A JOB neve mindig DBMS_JOB\n");
     d.printf("SUBMIT: JOB behelyezse a fut JOB-ok kz\n");
     d.printf(":JobNo: A JOB szma - a rendszer automatikusan adja\n");
     d.printf("'naplo_mod2;': A vgrehajtand trolt eljrs\n");
     d.printf("SYSDATE: Az indts idpontja (Jelentse: 1 ra mlva)\n");
     d.printf("'SYSDATE+1': A kvetkez indts idpontja (Jelentse: 1 nap mlva)\n");
      Sor(2);
     Alprog(12);
      Sor(4);
     enter = d.readLine("Tovbb: ENTER!");







      Sor(20);
     d.printf("\nAz adatbzis-kapcsolat bontshoz adjuk ki a conn.close() parancsot.");
}

public static void kezel(){
      fdb=0;
      Sor(18);
     d.printf("       Most nzzk meg, hogyan lehet egyszer menk segtsgvel\n");
     d.printf("       a konzolablakbl adatbzist kezelni:\n");
      Sor(7);
     String enter = d.readLine("Tovbb: ENTER!");
     
      Sor(7);
     if (user.length()==0){
        user = d.readLine("Krem a VirtualOracleXE azonositt: (system)");
        char[] pswdc = d.readPassword("Krem a jelszt [Nem rdik ki!!!] (jelszo): ");
        pswd = new String(pswdc);
     }
     Kapcs(user, pswd);
     menu();
     d.printf("\nGAME OVER, egy utols ENTER, bcslg: J munkt a sajt feladatodhoz!");
      Sor(3);
     enter = d.readLine();
      Sor(5);
     d.printf("\n                                                                          _");
     d.printf("\n               **   ********        *****      ********        *****     ||");
     d.printf("\n               **   *********      *******     *********     *********    -");
     d.printf("\n               **   **      **    **     **    **      **   **       **");
     d.printf("\n               **   **      **   **       **   **      **   **       **");
     d.printf("\n               **   **      **   **       **   **      **            **");
     d.printf("\n               **   **      **   **       **   *********            **");
     d.printf("\n               **   **      **   ***********   *********           **");
     d.printf("\n               **   **      **   ***********   **      **         **");
     d.printf("\n       **      **   **      **   **       **   **      **       **");
     d.printf("\n       **      **   **      **   **       **   **      **     **");
     d.printf("\n        ********    *********    **       **   *********    ***********");
     d.printf("\n         *****      ********     **       **   ********     ***********");
      Sor(4);
     d.printf("\nJava Demo AdatBzis 2 (v01.77) - by BitMan           : Brmire felhasznlhat");
}


  public static void main(String[] args) {
      Sor(5);
     d.printf("\n                                                                          _");
     d.printf("\n               **   ********        *****      ********        *****     ||");
     d.printf("\n               **   *********      *******     *********     *********    -");
     d.printf("\n               **   **      **    **     **    **      **   **       **");
     d.printf("\n               **   **      **   **       **   **      **   **       **");
     d.printf("\n               **   **      **   **       **   **      **            **");
     d.printf("\n               **   **      **   **       **   *********            **");
     d.printf("\n               **   **      **   ***********   *********           **");
     d.printf("\n               **   **      **   ***********   **      **         **");
     d.printf("\n       **      **   **      **   **       **   **      **       **");
     d.printf("\n       **      **   **      **   **       **   **      **     **");
     d.printf("\n        ********    *********    **       **   *********    ***********");
     d.printf("\n         *****      ********     **       **   ********     ***********");
      Sor(4);
     d.printf("\nJava Demo AdatBzis 2 (v01.77) - by BitMan           : Brmire felhasznlhat");
      Sor(2);
     String enter = d.readLine("Az okossgok elrshez nyomj ENTER-t!");
      Sor(10);
     if (args.length>0 && args[0].equals("menu")) {menu0();}
     else {oktat(); kezel();}
     Lekapcs();
  }
}













